
#include <sys/time.h>
#include <time.h> 
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
 
#include "LogTrace.h"

LogTrace *logTrace;


void log_functions::LOG_DEBUG(const char *str)
{
#ifdef __TRACE
   logTrace->LogDebug(str);
#else
   str = 0x00;
#endif
}


void log_functions::LOG_WARNING(const char *str)
{
#ifdef __TRACE
   logTrace->LogWarning(str);
#else
   str = 0x00;
#endif
}


void log_functions::START_FUNCTION_TRACE(const char *str)
{
#ifdef __TRACE
   logTrace->StartFunctionTrace(str);
#else
   str = 0x00;
#endif
}


void log_functions::END_FUNCTION_TRACE(const char *str)
{
#ifdef __TRACE
   logTrace->EndFunctionTrace(str);
#else
   str = 0x00;
#endif
}


LogTrace::LogTrace(const char *Program)
{
   QString logName = Program;
   logName += ".log";
   theLogFile.setName( logName );
#ifdef __TRACE   
   theLogFile.open(IO_WriteOnly);
#endif

#ifndef _WIN32
   theClicksPerSecond = sysconf(_SC_CLK_TCK);
#endif
}


LogTrace::~LogTrace()
{
   theLogFile.close();
}


void LogTrace::LogDebug(const char *Debug)
{
   char writeBuffer[255] = {'\0'};
   sprintf("DEBUG: %s\n", Debug);
   theLogFile.writeBlock( writeBuffer, strlen(writeBuffer) );
}


void LogTrace::LogWarning(const char *Warn)
{
   char writeBuffer[255] = {'\0'};
   sprintf("WARNING: %s\n", Warn);
   theLogFile.writeBlock( writeBuffer, strlen(writeBuffer) );
}


void LogTrace::StartFunctionTrace(const char *FStart)
{
   char           writeBuffer[255];
   time_t         ltime;
   struct tm      *today;
   struct timeval tstruct;

   // TODO: Add your control notification handler code here
   time( &ltime );

   // Get the current local time
   today = localtime( &ltime );

   gettimeofday(&tstruct, 0);
   
   sprintf( writeBuffer, "FUNCT START: %s StartTime: %02d:%02d:%02d:%ld\n",
            FStart,today->tm_hour,today->tm_min,today->tm_sec,tstruct.tv_usec );

   theLogFile.writeBlock( writeBuffer, strlen(writeBuffer) );
   theLogFile.flush();
}


void LogTrace::EndFunctionTrace(const char *FEnd)
{
   char           writeBuffer[255];
   time_t         ltime;
   struct tm      *today;
   struct timeval tstruct;
   
   // TODO: Add your control notification handler code here
   time( &ltime );

   // Get the current local time
   today = localtime( &ltime );

   gettimeofday(&tstruct, 0);
   
   sprintf( writeBuffer, "FUNCT END: %s StartTime: %02d:%02d:%02d:%ld\n",
            FEnd,today->tm_hour,today->tm_min,today->tm_sec,tstruct.tv_usec );

   theLogFile.writeBlock( writeBuffer, strlen(writeBuffer) );
   theLogFile.flush();
}

