#ifndef __LOG_TRACE_H__
#define __LOG_TRACE_H__

#include <qfile.h>

namespace log_functions 
{
   void LOG_DEBUG(const char *);
   void LOG_WARNING(const char *);

   void START_FUNCTION_TRACE(const char *);
   void END_FUNCTION_TRACE(const char *);
}


class LogTrace
{
public:
   LogTrace(const char *);
   ~LogTrace();

private:
   QFile  theLogFile;
   double theClicksPerSecond;

   friend void log_functions::LOG_DEBUG(const char *);
   friend void log_functions::LOG_WARNING(const char *);

   friend void log_functions::START_FUNCTION_TRACE(const char *);
   friend void log_functions::END_FUNCTION_TRACE(const char *);

   void LogDebug(const char *);
   void LogWarning(const char *);

   void StartFunctionTrace(const char *);
   void EndFunctionTrace(const char *);
};

extern LogTrace *logTrace;

#endif
