/***************************************************************************
                          startscreen.h  -  description
                             -------------------
    begin                : Wed Aug 21 01:49:10 EDT 2002
    copyright            : (C) 2002 by Kevin Greenhaw
    email                : kevin_greenhaw@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __TRACK_IMAGE_H__
#define __TRACK_IMAGE_H__

#include "bridge_tracks.h"
#include "track.h"

//#include "Vertical.h"
//#include "VerticalBridge.h"
//#include "Horizontal.h"
//#include "HorizontalBridge.h"
//#include "UpperLeft.h"
//#include "UpperRight.h"
//#include "LowerLeft.h"
//#include "LowerRight.h"
//#include "Grass.h"


const int LAYERS  = 2;
const int ROWS    = 4;
const int COLUMNS = 3;
const int LEVEL   = 3;

const int MAX_TRACKS = 14;  // Zero Based Value. i.e. (0, 1, 2) not (1, 2, 3)

typedef enum trackPieces
{
   GRASS,
   VERT,
   VERT_BRIDGE,
   HORIZ,
   HORIZ_BRIDGE,
   HORIZ_START,
   RIGHT_UPPER,
   RIGHT_UPPER_BRIDGE,
   RIGHT_LOWER,
   RIGHT_LOWER_BRIDGE,
   LEFT_UPPER,
   LEFT_UPPER_BRIDGE,
   LEFT_LOWER,
   LEFT_LOWER_BRIDGE,
   START_TRACK,
   START_TRACK_BRIDGE,
   RIGHT_UPPER_BRIDGE_START,
   UNDEFINED
} TrackPieces;

typedef enum theDirection
{
   LEFT,
   RIGHT,
   UP,
   DOWN,
   NONE
} direction;

typedef struct trackComponents
{
   TrackPieces TrackImage[LAYERS][ROWS][COLUMNS];
   direction   TrackDirection[LAYERS][ROWS][COLUMNS];
}TrackComponents;


/* TRACK IMAGE 1 */
const TrackPieces TrackImage1[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,  HORIZ,     RIGHT_UPPER},
    {START_TRACK, GRASS,     VERT},
    {VERT,        GRASS,     VERT},
    {LEFT_LOWER,  HORIZ,     RIGHT_LOWER}},
   {{UNDEFINED,   UNDEFINED, UNDEFINED},
    {UNDEFINED,   UNDEFINED, UNDEFINED},
    {UNDEFINED,   UNDEFINED, UNDEFINED},
    {UNDEFINED,   UNDEFINED, UNDEFINED}}
};

const direction TrackDirection1[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, RIGHT},
    {UP,    NONE,  DOWN},
    {UP,    NONE,  DOWN},
    {RIGHT, LEFT,  RIGHT}},
   {{NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize1 = 10;



/* TRACK IMAGE 2 */
const TrackPieces TrackImage2[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,  RIGHT_UPPER, GRASS},
    {START_TRACK, LEFT_LOWER,  RIGHT_UPPER},
    {VERT,        LEFT_UPPER,  RIGHT_LOWER},
    {LEFT_LOWER,  RIGHT_LOWER, GRASS}},
   {{UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED}}
};


const direction TrackDirection2[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, NONE},
    {UP,    LEFT,  RIGHT},
    {UP,    LEFT,  RIGHT},
    {RIGHT, RIGHT, NONE}},
   {{NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize2 = 10;



/* TRACK IMAGE 3 */
const TrackPieces TrackImage3[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,  HORIZ,      RIGHT_UPPER},
    {START_TRACK, LEFT_UPPER, RIGHT_LOWER},
    {VERT,        LEFT_LOWER, RIGHT_UPPER},
    {LEFT_LOWER,  HORIZ,      RIGHT_LOWER}},
   {{UNDEFINED,   UNDEFINED,  UNDEFINED,},
    {UNDEFINED,   UNDEFINED,  UNDEFINED,},
    {UNDEFINED,   UNDEFINED,  UNDEFINED,},
    {UNDEFINED,   UNDEFINED,  UNDEFINED}}
};

const direction TrackDirection3[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, RIGHT},
    {UP,    LEFT,  RIGHT},
    {UP,    LEFT,  RIGHT},
    {RIGHT, LEFT,  RIGHT}},
   {{NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize3 = 12;



/* TRACK IMAGE 4 */
const TrackPieces TrackImage4[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER_BRIDGE,  HORIZ,     RIGHT_UPPER},
    {LEFT_UPPER,         HORIZ,     RIGHT_LOWER},
    {LEFT_LOWER,         HORIZ,     RIGHT_UPPER},
    {LEFT_LOWER_BRIDGE,  HORIZ,     RIGHT_LOWER}},
   {{UNDEFINED,          UNDEFINED, UNDEFINED},
    {START_TRACK_BRIDGE, UNDEFINED, UNDEFINED},
    {VERT_BRIDGE,        UNDEFINED, UNDEFINED},
    {UNDEFINED,          UNDEFINED, UNDEFINED}}
};

const direction TrackDirection4[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, RIGHT},
    {LEFT, LEFT, RIGHT},
    {LEFT, RIGHT, RIGHT},
    {RIGHT, LEFT, RIGHT}},
   {{NONE, NONE, NONE},
    {UP, NONE, NONE},
    {UP, NONE, NONE},
    {NONE, NONE, NONE}}
};

const int TrackSize4 = 14;



/* TRACK IMAGE 5 */
const TrackPieces TrackImage5[LAYERS][ROWS][COLUMNS] =
{
   {{GRASS,      LEFT_UPPER_BRIDGE,  RIGHT_UPPER},
    {LEFT_UPPER, HORIZ,              RIGHT_LOWER},
    {LEFT_LOWER, HORIZ,              RIGHT_UPPER},
    {GRASS,      LEFT_LOWER_BRIDGE,  RIGHT_LOWER}},
   {{UNDEFINED,  UNDEFINED,          UNDEFINED},
    {UNDEFINED,  START_TRACK_BRIDGE, UNDEFINED},
    {UNDEFINED,  VERT_BRIDGE,        UNDEFINED},
    {UNDEFINED,  UNDEFINED,          UNDEFINED}}
};

const direction TrackDirection5[LAYERS][ROWS][COLUMNS] =
{
   {{NONE, RIGHT, RIGHT},
    {LEFT, LEFT, RIGHT},
    {LEFT, RIGHT, RIGHT},
    {NONE, RIGHT, RIGHT}},
   {{NONE, NONE, NONE},
    {NONE, UP, NONE},
    {NONE, UP, NONE},
    {NONE, NONE, NONE}}
};

const int TrackSize5 = 12;

/* TRACK IMAGE 6 */
const TrackPieces TrackImage6[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,  HORIZ,       RIGHT_UPPER},
    {START_TRACK, LEFT_UPPER,  RIGHT_LOWER},
    {VERT       , VERT,        GRASS},
    {LEFT_LOWER,  RIGHT_LOWER, GRASS}},
   {{UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED}}
};

const direction TrackDirection6[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, RIGHT},
    {UP,    LEFT,  RIGHT},
    {UP,    DOWN,  NONE},
    {RIGHT, RIGHT, NONE}},
   {{NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE}}
};

const int TrackSize6 = 10;


/* TRACK IMAGE 7 */
const TrackPieces TrackImage7[LAYERS][ROWS][COLUMNS] =
{
   {{GRASS,       LEFT_UPPER,  RIGHT_UPPER},
    {LEFT_UPPER,  RIGHT_LOWER, VERT},
    {START_TRACK, LEFT_UPPER,  RIGHT_LOWER},
    {LEFT_LOWER,  RIGHT_LOWER, GRASS}},
   {{UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED}}
};

const direction TrackDirection7[LAYERS][ROWS][COLUMNS] =
{
   {{NONE,  RIGHT, RIGHT},
    {RIGHT, LEFT,  DOWN},
    {UP,    LEFT,  RIGHT},
    {RIGHT, RIGHT, NONE}},
   {{NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE}}
};

const int TrackSize7 = 10;


/* TRACK IMAGE 8 */
const TrackPieces TrackImage8[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,  RIGHT_UPPER, GRASS},
    {VERT,        LEFT_LOWER,  RIGHT_UPPER},
    {START_TRACK, GRASS,       VERT},
    {LEFT_LOWER,  HORIZ,       RIGHT_LOWER}},
   {{UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED},
    {UNDEFINED,   UNDEFINED,   UNDEFINED}}
};

const direction TrackDirection8[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, NONE},
    {UP,    LEFT,  RIGHT},
    {UP,    NONE,  DOWN},
    {RIGHT, LEFT, RIGHT}},
   {{NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE},
    {NONE,  NONE, NONE}}
};

const int TrackSize8 = 10;

/* TRACK IMAGE 9 */
const TrackPieces TrackImage9[LAYERS][ROWS][COLUMNS] =
{
   {{GRASS,             LEFT_UPPER,  RIGHT_UPPER},
    {LEFT_UPPER_BRIDGE, VERT,        RIGHT_LOWER_BRIDGE},
    {START_TRACK,       VERT,        GRASS},
    {LEFT_LOWER,        RIGHT_LOWER, GRASS}},
   {{UNDEFINED,         UNDEFINED,   UNDEFINED},
    {UNDEFINED,         HORIZ_BRIDGE,UNDEFINED},
    {UNDEFINED,         UNDEFINED,   UNDEFINED},
    {UNDEFINED,         UNDEFINED,   UNDEFINED}}
};

const direction TrackDirection9[LAYERS][ROWS][COLUMNS] =
{
   {{NONE,  LEFT,  LEFT},
    {RIGHT, DOWN,  LEFT},
    {UP,    DOWN,  NONE},
    {RIGHT, RIGHT, NONE}},
   {{NONE,  NONE,  NONE},
    {NONE,  RIGHT, NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize9 = 10;

/* TRACK IMAGE 10 */
const TrackPieces TrackImage10[LAYERS][ROWS][COLUMNS] =
{
   {{GRASS,             LEFT_UPPER,  RIGHT_UPPER},
    {LEFT_UPPER_BRIDGE, VERT,        RIGHT_LOWER_BRIDGE},
    {START_TRACK,       LEFT_LOWER,  RIGHT_UPPER},
    {LEFT_LOWER,        HORIZ,       RIGHT_LOWER}},
   {{UNDEFINED,         UNDEFINED,   UNDEFINED},
    {UNDEFINED,         HORIZ_BRIDGE,UNDEFINED},
    {UNDEFINED,         UNDEFINED,   UNDEFINED},
    {UNDEFINED,         UNDEFINED,   UNDEFINED}}
};

const direction TrackDirection10[LAYERS][ROWS][COLUMNS] =
{
   {{NONE,  LEFT,  LEFT},
    {RIGHT, DOWN,  LEFT},
    {UP,    LEFT,  RIGHT},
    {RIGHT, LEFT,  RIGHT}},
   {{NONE,  NONE,  NONE},
    {NONE,  RIGHT, NONE},
    {NONE,  NONE,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize10 = 12;


/* TRACK IMAGE 11 */
const TrackPieces TrackImage11[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER, RIGHT_UPPER_BRIDGE, GRASS},
    {LEFT_LOWER, HORIZ,              RIGHT_UPPER},
    {LEFT_UPPER, HORIZ,              RIGHT_LOWER},
    {LEFT_LOWER, RIGHT_LOWER_BRIDGE, GRASS}},
   {{UNDEFINED,  UNDEFINED,          UNDEFINED},
    {UNDEFINED,  START_TRACK_BRIDGE, UNDEFINED},
    {UNDEFINED,  VERT_BRIDGE,        UNDEFINED},
    {UNDEFINED,  UNDEFINED,          UNDEFINED}}
};

const direction TrackDirection11[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT, LEFT,  NONE},
    {LEFT, RIGHT, RIGHT},
    {LEFT, LEFT,  RIGHT},
    {LEFT, LEFT,  NONE}},
   {{NONE, NONE,  NONE},
    {NONE, UP,    NONE},
    {NONE, UP,    NONE},
    {NONE, NONE,  NONE}}
};

const int TrackSize11 = 12;


/* TRACK IMAGE 12 */
const TrackPieces TrackImage12[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER, HORIZ,              RIGHT_UPPER},
    {LEFT_LOWER, RIGHT_UPPER,        START_TRACK},
    {LEFT_UPPER, RIGHT_LOWER,        VERT},
    {LEFT_LOWER, HORIZ,              RIGHT_LOWER}},
   {{UNDEFINED,  UNDEFINED,          UNDEFINED},
    {UNDEFINED,  UNDEFINED,          UNDEFINED},
    {UNDEFINED,  UNDEFINED,          UNDEFINED},
    {UNDEFINED,  UNDEFINED,          UNDEFINED}}
};

const direction TrackDirection12[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT, LEFT,  LEFT},
    {LEFT, RIGHT, UP},
    {LEFT, RIGHT, UP},
    {LEFT, RIGHT, LEFT}},
   {{NONE, NONE,  NONE},
    {NONE, NONE,  NONE},
    {NONE, NONE,  NONE},
    {NONE, NONE,  NONE}}
};

const int TrackSize12 = 12;


/* TRACK IMAGE 13 */
const TrackPieces TrackImage13[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER, HORIZ,     RIGHT_UPPER_BRIDGE},
    {LEFT_LOWER, HORIZ,     RIGHT_UPPER},
    {LEFT_UPPER, HORIZ,     RIGHT_LOWER},
    {LEFT_LOWER, HORIZ,     RIGHT_LOWER_BRIDGE}},
   {{UNDEFINED,  UNDEFINED, UNDEFINED},
    {UNDEFINED,  UNDEFINED, START_TRACK_BRIDGE},
    {UNDEFINED,  UNDEFINED, VERT_BRIDGE},
    {UNDEFINED,  UNDEFINED, UNDEFINED}}
};

const direction TrackDirection13[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT, LEFT,  LEFT},
    {LEFT, RIGHT, RIGHT},
    {LEFT, LEFT,  RIGHT},
    {LEFT, RIGHT, LEFT}},
   {{NONE, NONE,  NONE},
    {NONE, NONE,  UP},
    {NONE, NONE,  UP},
    {NONE, NONE,  NONE}}
};

const int TrackSize13 = 14;


/* TRACK IMAGE 14 */
const TrackPieces TrackImage14[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,        RIGHT_UPPER,              GRASS},
    {LEFT_LOWER_BRIDGE, LEFT_LOWER,               RIGHT_UPPER},
    {LEFT_UPPER_BRIDGE, GRASS,                    VERT},
    {LEFT_LOWER,        HORIZ_START,              RIGHT_LOWER}},
   {{UNDEFINED,         UNDEFINED,                UNDEFINED},
    {UNDEFINED,         RIGHT_UPPER_BRIDGE,       UNDEFINED},
    {UNDEFINED,         RIGHT_LOWER_BRIDGE,       UNDEFINED},
    {UNDEFINED,         UNDEFINED,                UNDEFINED}}
};


const direction TrackDirection14[LAYERS][ROWS][COLUMNS] =
{
   {{RIGHT, RIGHT, NONE},
    {RIGHT, LEFT,  RIGHT},
    {RIGHT, NONE,  DOWN},
    {RIGHT, LEFT,  RIGHT}},
   {{NONE,  NONE,  NONE},
    {NONE,  LEFT,  NONE},
    {NONE,  LEFT,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize14 = 12;


/* TRACK IMAGE 15 */
const TrackPieces TrackImage15[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT_UPPER,        HORIZ_START,        RIGHT_UPPER},
    {LEFT_LOWER,        RIGHT_UPPER,        RIGHT_LOWER_BRIDGE},
    {LEFT_UPPER_BRIDGE, LEFT_LOWER,         RIGHT_UPPER},
    {LEFT_LOWER,        HORIZ,              RIGHT_LOWER}},
   {{UNDEFINED,         UNDEFINED,          UNDEFINED},
    {UNDEFINED,         LEFT_UPPER_BRIDGE,  UNDEFINED},
    {UNDEFINED,         RIGHT_LOWER_BRIDGE, UNDEFINED},
    {UNDEFINED,         UNDEFINED,          UNDEFINED}}
};


const direction TrackDirection15[LAYERS][ROWS][COLUMNS] =
{
   {{LEFT,  LEFT,  LEFT},
    {LEFT,  RIGHT, LEFT},
    {RIGHT, LEFT,  RIGHT},
    {RIGHT, LEFT,  RIGHT}},
   {{NONE,  NONE,  NONE},
    {NONE,  RIGHT, NONE},
    {NONE,  LEFT,  NONE},
    {NONE,  NONE,  NONE}}
};

const int TrackSize15 = 14;


#endif
