/***************************************************************************
                         user_settings.h  -  description
                             -------------------
    begin                : Wed Aug 21 01:49:10 EDT 2002
    copyright            : (C) 2002 by Kevin Greenhaw
    email                : kevin_greenhaw@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __USER_SETTINGS_H__
#define __USER_SETTINGS_H__

#include <qglobal.h>
#include <qmap.h>

#ifndef Z_QT
   #include <qpe/config.h>
#else
   #if QT_VERSION > 233
      #include <qsettings.h>
   #endif
#endif

class UserSettings
{
public:
   UserSettings();

   void   ReadFastestRaceTime();
   void   WriteFastestRaceTime();
   void   UpdateFastestRaceTime(int TrackID, int Laps, double LapTime);
   double FastestRaceTime(int TrackID, int Laps);

private:
   enum TrackIDs {
      TRACK1,
      TRACK2,
      TRACK3,
      TRACK4,
      TRACK5,
      TRACK6,
      TRACK7,
      TRACK8,
      TRACK9,
      TRACK10,
      TRACK11,
      TRACK12,
      TRACK13,
      TRACK14,
      TRACK15
   };

   QMap<int, double> FiveLapRace;
   QMap<int, double> TenLapRace;
   QMap<int, double> FifteenLapRace;
   QMap<int, double> TwentyLapRace;
   QMap<int, double> TwentyFiveLapRace;
};

extern UserSettings *zRallyConfig;
#endif

