/***************************************************************************
                          zrally.h  -  description
                             -------------------
    begin                : Wed Aug 21 01:49:10 EDT 2002
    copyright            : (C) 2002 by Kevin Greenhaw
    email                : kevin_greenhaw@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __ZRALLY_H__
#define __ZRALLY_H__

#ifdef Z_QT
   #include <qmainwindow.h>
#else
   #include <qwidget.h>
#endif

#include <qevent.h>
#include <qmap.h>
#include <qcanvas.h>

class ZScreen;
class StartScreen;
class EndScreen;

#ifdef Z_QT
//class ZRally : public QMainWindow
#else
class ZRally : public QWidget
#endif
{
    Q_OBJECT
             
public:
#ifdef Z_QT
   ZRally();
#else
   ZRally(QWidget *parent = 0, const char *name = 0);
#endif
   ~ZRally();

   void Start();
   QCanvasPolygonalItem *GetTrackImage(int ImageIndex);
   
public slots:
   void RaceStart();
   void ReturnToStart();
   void RaceLevel(int);
   void RaceLength(int);
   void RaceTrack(int);
   void RaceFinished(bool, long);
   void quit();

private:
   QString      picsDirectory;
   QCanvas      canvas;
   
   ZScreen     *zScreen;
   StartScreen *startScreen;
   EndScreen   *endScreen;

   bool AcceptKeyPressEvent;
   bool SetupComplete;
   bool RaceStarted;
   bool RaceIsOver;

   int RaceDifficulty;
   int NumberOfLaps;
   int SelectedTrack;

   QList<QCanvasPolygonalItem> TrackList;

   bool LoadTrackImages();
   void keyPressEvent( QKeyEvent *k );
   void keyReleaseEvent( QKeyEvent *k );
};

extern ZRally *zrally;

#endif
